"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var OperationError_1 = __importDefault(require("@InternalErrors/OperationError"));
var ObjectFloat_1 = __importDefault(require("@Types/ObjectFloat"));
var OperatorBase_1 = __importDefault(require("@Operators/OperatorBase"));
var Sum = /** @class */ (function (_super) {
    __extends(Sum, _super);
    /**
     * Creates an instance of Sum.
     * @memberof Sum
     */
    function Sum() {
        return _super.call(this, ObjectFloat_1.default) || this;
    }
    /**
     * @returns {ObjectFloat}
     * @memberof Sum
     */
    Sum.prototype.apply = function () {
        this.typeCheckLeft();
        this.typeCheckRight();
        try {
            return new ObjectFloat_1.default(this.leftType.value() + this.rightType.value());
        }
        catch (_a) {
            throw OperationError_1.default.create(this, this.leftType, this.rightType);
        }
    };
    /**
     * @returns {string}
     * @memberof Sum
     */
    Sum.prototype.name = function () {
        return "[operator Sum]";
    };
    return Sum;
}(OperatorBase_1.default));
exports.default = Sum;
