"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var OperatorBase_1 = __importDefault(require("@Operators/OperatorBase"));
var ObjectError_1 = __importDefault(require("@Types/ObjectError"));
var ObjectString_1 = __importDefault(require("@Types/ObjectString"));
var Throw = /** @class */ (function (_super) {
    __extends(Throw, _super);
    function Throw() {
        return _super.call(this, ObjectError_1.default) || this;
    }
    Throw.prototype.apply = function () {
        var error = new Error();
        // @ts-ignore
        error.message = this.leftType.message.value();
        error.stack = this.leftType.stack.value();
        error.name = this.leftType.name();
        throw error;
    };
    Throw.prototype.name = function () {
        return "[operator Throw]";
    };
    Throw.prototype.right = function () {
        var arg = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            arg[_i] = arguments[_i];
        }
        var op = new Throw();
        op.left(new ObjectError_1.default(new ObjectString_1.default("Throw operator cannot does not have a right side")));
        op.apply();
        return this;
    };
    return Throw;
}(OperatorBase_1.default));
exports.default = Throw;
