import OperatorBase from '@Operators/OperatorBase';
import ObjectFunction from '@Types/ObjectFunction';
import TypeBase from '@Types/TypeBase';
import ObjectError from '@Types/ObjectError';
export default class TryCatch extends OperatorBase<ObjectFunction<(...args: any[]) => TypeBase>, ObjectFunction<(...args: any[]) => ObjectError>> {
    constructor();
    apply(...args: any[]): TypeBase<unknown>;
    catch(arg: ObjectFunction<(...args: any[]) => ObjectError>): this;
    try<K>(arg: ObjectFunction<(...args: any[]) => TypeBase<K>>): this;
    name(): string;
}
