"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var OperatorBase_1 = __importDefault(require("@Operators/OperatorBase"));
var ObjectFunction_1 = __importDefault(require("@Types/ObjectFunction"));
var TryCatch = /** @class */ (function (_super) {
    __extends(TryCatch, _super);
    function TryCatch() {
        return _super.call(this, ObjectFunction_1.default) || this;
    }
    TryCatch.prototype.apply = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        try {
            return this.leftType.apply(args);
        }
        catch (error) {
            return this.rightType.call();
        }
    };
    TryCatch.prototype.catch = function (arg) {
        return this.right(arg);
    };
    TryCatch.prototype.try = function (arg) {
        return this.left(arg);
    };
    TryCatch.prototype.name = function () {
        return "[operator TryCatch]";
    };
    return TryCatch;
}(OperatorBase_1.default));
exports.default = TryCatch;
