"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ObjectError_1 = __importDefault(require("@Types/ObjectError"));
var ObjectString_1 = __importDefault(require("@Types/ObjectString"));
var NullPointerError = /** @class */ (function (_super) {
    __extends(NullPointerError, _super);
    function NullPointerError() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NullPointerError.create = function (key, caller) {
        return new NullPointerError(new ObjectString_1.default("Null pointer error on " + caller.name() + " with key " + key.value()));
    };
    NullPointerError.prototype.name = function () {
        return "[error NullPointerError]";
    };
    return NullPointerError;
}(ObjectError_1.default));
exports.default = NullPointerError;
