import ObjectError from '@Types/ObjectError';
import TypeBase from '@Types/TypeBase';
import OperatorBase from '@Operators/OperatorBase';
export default class OperationError extends ObjectError {
    static create<L extends TypeBase, R extends TypeBase>(operator: OperatorBase<L, R>, left: L, right: R): OperationError;
    name(): string;
}
