"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ObjectError_1 = __importDefault(require("@Types/ObjectError"));
var ObjectString_1 = __importDefault(require("@Types/ObjectString"));
var OperationError = /** @class */ (function (_super) {
    __extends(OperationError, _super);
    function OperationError() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OperationError.create = function (operator, left, right) {
        return new OperationError(new ObjectString_1.default("Invalid operation " + operator.name() + " with left " + left.name() + " and right " + right.name()));
    };
    OperationError.prototype.name = function () {
        return "[error OperationError]";
    };
    return OperationError;
}(ObjectError_1.default));
exports.default = OperationError;
