import ObjectInt from '@Types/ObjectInt';
import TypeBase from '@Types/TypeBase';
export default class ObjectChar extends TypeBase<string> {
    /**
     * Creates an instance of ObjectChar.
     * @param {string} char
     * @memberof ObjectChar
     */
    constructor(char: string | number);
    /**
     * @template T
     * @param {T} type
     * @returns {string}
     * @memberof Char
     */
    cast<T extends TypeBase<unknown>>(type: T): ObjectChar;
    /**
     * @returns {ObjectInt}
     * @memberof ObjectChar
     */
    charCode(): ObjectInt;
    /**
     * @returns {string}
     * @memberof Char
     */
    name(): string;
    /**
     * @returns {boolean}
     * @memberof Char
     */
    nullable(): boolean;
    /**
     * @returns {ObjectInt}
     * @memberof ObjectChar
     */
    toInt(): ObjectInt;
}
