import TypeBase from '@Types/TypeBase';
export default class ObjectFunction<TFunction extends (...args: any[]) => TypeBase> extends TypeBase<TFunction> {
    cast<T extends TypeBase<unknown>>(type: T): TypeBase<TFunction>;
    apply<TArgs extends Array<TypeBase>>(args: TArgs): ReturnType<TFunction>;
    call<TArgs extends Array<TypeBase>>(...args: TArgs): ReturnType<TFunction>;
    name(): string;
    nullable(): boolean;
}
