"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var TypeBase_1 = __importDefault(require("@Types/TypeBase"));
var InvalidCastError_1 = __importDefault(require("@InternalErrors/InvalidCastError"));
var ObjectNull = /** @class */ (function (_super) {
    __extends(ObjectNull, _super);
    function ObjectNull() {
        var _this = _super.call(this, TypeBase_1.default.skipToken) || this;
        _this['underlyingValue'] = null;
        return _this;
    }
    ObjectNull.prototype.cast = function (value) {
        if (value.nullable()) {
            return new ObjectNull();
        }
        throw new InvalidCastError_1.default("Type " + value.name() + " is not nullable");
    };
    ObjectNull.prototype.name = function () {
        return "[object Null]";
    };
    ObjectNull.prototype.nullable = function () {
        return true;
    };
    return ObjectNull;
}(TypeBase_1.default));
exports.default = ObjectNull;
