import TypeBase from '@Types/TypeBase';
export default class ObjectObject extends TypeBase<object> {
    [index: string]: TypeBase | TypeBase['cast'] | TypeBase['equalsTo'] | TypeBase['name'] | TypeBase['nullable'] | TypeBase['toString'] | TypeBase['underlyingValue'] | TypeBase['value'];
    constructor(value?: unknown);
    /**
     * @template T
     * @param {T} type
     * @returns {object}
     * @memberof ObjectObject
     */
    cast<T extends TypeBase<unknown>>(type: T): ObjectObject;
    /**
     * @returns {string}
     * @memberof ObjectObject
     */
    name(): string;
    /**
     * @returns {boolean}
     * @memberof ObjectObject
     */
    nullable(): boolean;
}
