import OperatorBase from '../Operators/OperatorBase';
import TypeBase from '@Types/TypeBase';
export default class OperationError extends TypeError {
    static create<L extends TypeBase, R extends TypeBase>(operator: OperatorBase<L, R>, left: L, right: R): OperationError;
    name: string;
}
