"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var OperatorBase_1 = __importDefault(require("./OperatorBase"));
var ObjectVariable_1 = __importDefault(require("@Types/ObjectVariable"));
var ObjectString_1 = __importDefault(require("@Types/ObjectString"));
var Assign = /** @class */ (function (_super) {
    __extends(Assign, _super);
    function Assign() {
        return _super.call(this, ObjectString_1.default) || this;
    }
    Assign.prototype.apply = function () {
        return new ObjectVariable_1.default(this.rightType.getType(), this.leftType, this.rightType);
    };
    Assign.prototype.name = function () {
        return "[operator Assign]";
    };
    return Assign;
}(OperatorBase_1.default));
exports.default = Assign;
