"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ObjectBoolean_1 = __importDefault(require("@Types/ObjectBoolean"));
var OperatorBase_1 = __importDefault(require("@Operators/OperatorBase"));
var ObjectFloat_1 = __importDefault(require("@Types/ObjectFloat"));
var GreaterThan = /** @class */ (function (_super) {
    __extends(GreaterThan, _super);
    function GreaterThan() {
        return _super.call(this, ObjectFloat_1.default) || this;
    }
    GreaterThan.prototype.apply = function () {
        return new ObjectBoolean_1.default(this.leftType.value() > this.rightType.value());
    };
    GreaterThan.prototype.name = function () {
        return "[operator GreaterThan]";
    };
    return GreaterThan;
}(OperatorBase_1.default));
exports.default = GreaterThan;
