"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Assign_1 = __importDefault(require("@Operators/Assign"));
var ObjectString_1 = __importDefault(require("@Types/ObjectString"));
var ObjectVariable_1 = __importDefault(require("@Types/ObjectVariable"));
var ObjectInt_1 = __importDefault(require("@Types/ObjectInt"));
describe("Assign", function () {
    test("Can assign a value", function () {
        expect(function () { return new Assign_1.default(); }).not.toThrowError();
        var assignment = new Assign_1.default();
        assignment.left(new ObjectString_1.default('varname'));
        assignment.right(new ObjectInt_1.default(10000));
        expect(function () { return assignment.apply(); }).not.toThrowError();
        expect(assignment.apply()).toBeDefined();
        expect(assignment.apply().signedName().value()).toBe('varname');
        expect(assignment.apply().name()).toBe(new ObjectVariable_1.default(ObjectString_1.default, new ObjectString_1.default(""), new ObjectString_1.default('')).name());
    });
});
