import OperatorBase from '@Operators/OperatorBase';
import { ConstructorOf } from '@Types/ConstructorOf';
import TypeBase from '@Types/TypeBase';
export declare function mathOperatorBase<L extends TypeBase<number>, R extends TypeBase<number>>(Operator: ConstructorOf<OperatorBase<L, R>>, Left: ConstructorOf<L>, Right: ConstructorOf<R>): (leftValue: number, rightValue: number, expected: number) => void;
export declare function mathOperatorBaseThrow<L extends TypeBase<number>, R extends TypeBase<number>>(Operator: ConstructorOf<OperatorBase<L, R>>, ThrowableType: ConstructorOf<TypeBase<any>>): void;
