import { ConstructorOf } from '@Types/ConstructorOf';
import TypeBase from '@Types/TypeBase';
import ObjectVoid from '@Types/ObjectVoid';
import ObjectString from '@Types/ObjectString';
export declare function construct<T extends TypeBase<K>, K>(Type: ConstructorOf<T>, args: K): T;
export declare function createType<T>(TypeName: ObjectString): ConstructorOf<TypeBase<T>>;
export declare function defineProperty<T extends TypeBase<K>, K>(Type: ConstructorOf<T>, propertyName: ObjectString, property: TypeBase): ObjectVoid;
export declare function typeOf<T extends TypeBase<K>, K>(Type: ConstructorOf<T>): string;
