import TypeBase from '@Types/TypeBase';
import ObjectVariable from '@Types/ObjectVariable';
import ObjectString from '@Types/ObjectString';
import ObjectObject from '@Types/ObjectObject';
import ObjectNull from '@Types/ObjectNull';
import ObjectArray from '@Types/ObjectArray';
export default class DeclarationTableExpression extends ObjectObject {
    constructor(variables?: ObjectArray<ObjectVariable>);
    add(variable: ObjectVariable): DeclarationTableExpression;
    cast<T extends TypeBase<unknown>>(type: T): any;
    get(name: ObjectString): ObjectVariable | ObjectNull;
    name(): string;
    nullable(): boolean;
}
