import TypeBase from '@Types/TypeBase';
import ObjectString from '@Types/ObjectString';
export default class ObjectError extends TypeBase<never> {
    message: ObjectString;
    stack: ObjectString;
    constructor(errorMessage?: ObjectString);
    cast<T extends TypeBase<unknown>>(type: T): never;
    name(): string;
    nullable(): boolean;
    throw(): void;
}
