"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var InvalidCastError_1 = __importDefault(require("@InternalErrors/InvalidCastError"));
var TypeBase_1 = __importDefault(require("@Types/TypeBase"));
var ObjectFunction = /** @class */ (function (_super) {
    __extends(ObjectFunction, _super);
    function ObjectFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ObjectFunction.prototype.cast = function (type) {
        throw InvalidCastError_1.default.create(type, this);
    };
    ObjectFunction.prototype.apply = function (args) {
        return this['underlyingValue'].apply(null, args);
    };
    ObjectFunction.prototype.call = function () {
        var _a;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return (_a = this['underlyingValue']).call.apply(_a, [null].concat(args));
    };
    ObjectFunction.prototype.name = function () {
        return "[object Function]";
    };
    ObjectFunction.prototype.nullable = function () {
        return false;
    };
    return ObjectFunction;
}(TypeBase_1.default));
exports.default = ObjectFunction;
