"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ObjectBoolean_1 = __importDefault(require("@Types/ObjectBoolean"));
var basetests = __importStar(require("./__ignore__/baseTests"));
describe(ObjectBoolean_1.default.name, function () {
    basetests.hasEqualsTo(ObjectBoolean_1.default);
    basetests.hasName(ObjectBoolean_1.default);
    basetests.hasToString(ObjectBoolean_1.default);
    basetests.hasValue(ObjectBoolean_1.default);
    basetests.isNullable(ObjectBoolean_1.default, false);
    test(ObjectBoolean_1.default.prototype.isFalse.name, function () {
        expect(new ObjectBoolean_1.default(false).isFalse().value()).toBeTruthy();
        expect(new ObjectBoolean_1.default(false).isTrue().value()).toBeFalsy();
    });
    test(ObjectBoolean_1.default.prototype.isTrue.name, function () {
        expect(new ObjectBoolean_1.default(true).isTrue().value()).toBeTruthy();
        expect(new ObjectBoolean_1.default(true).isFalse().value()).toBeFalsy();
    });
});
