"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ObjectChar_1 = __importDefault(require("@Types/ObjectChar"));
var basetests = __importStar(require("./__ignore__/baseTests"));
var ObjectInt_1 = __importDefault(require("@Types/ObjectInt"));
describe(ObjectChar_1.default.name, function () {
    basetests.hasEqualsTo(ObjectChar_1.default);
    basetests.hasName(ObjectChar_1.default);
    basetests.hasToString(ObjectChar_1.default);
    basetests.hasValue(ObjectChar_1.default);
    basetests.isNullable(ObjectChar_1.default, false);
    test(ObjectChar_1.default.prototype.charCode.name, function () {
        var char = new ObjectChar_1.default('a');
        expect(char.charCode().value()).toBe(97);
    });
    test(ObjectChar_1.default.prototype.toInt.name, function () {
        var char = new ObjectChar_1.default('b');
        expect(char.toInt().name()).toBe(new ObjectInt_1.default(1).name());
        expect(char.toInt().value()).toBe(98);
    });
});
