"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ObjectDecimal_1 = __importDefault(require("@Types/ObjectDecimal"));
var basetests = __importStar(require("./__ignore__/baseTests"));
var ObjectInt_1 = __importDefault(require("@Types/ObjectInt"));
describe(ObjectDecimal_1.default.name, function () {
    basetests.hasEqualsTo(ObjectDecimal_1.default);
    basetests.hasName(ObjectDecimal_1.default);
    basetests.hasToString(ObjectDecimal_1.default);
    basetests.hasValue(ObjectDecimal_1.default);
    basetests.isNullable(ObjectDecimal_1.default, false);
    test(ObjectDecimal_1.default.prototype.cast.name, function () {
        var int = new ObjectInt_1.default(10);
        var decimal = new ObjectDecimal_1.default(10.222);
        expect(decimal.value()).toBe(10.22);
        expect(decimal.cast(int).value()).toBe(10.00);
    });
});
