"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ObjectObject_1 = __importDefault(require("@Types/ObjectObject"));
var basetests = __importStar(require("./__ignore__/baseTests"));
var ObjectString_1 = __importDefault(require("@Types/ObjectString"));
describe(ObjectObject_1.default.name, function () {
    basetests.hasEqualsTo(ObjectObject_1.default);
    basetests.hasName(ObjectObject_1.default);
    basetests.hasToString(ObjectObject_1.default);
    basetests.hasValue(ObjectObject_1.default);
    basetests.isNullable(ObjectObject_1.default, true);
    test('On object you can add custom properties', function () {
        var obj = new ObjectObject_1.default({});
        obj.foo = new ObjectString_1.default('hello');
        expect(obj).toHaveProperty('foo');
    });
});
